diff --git a/tests/test_cli.py b/tests/test_cli.py
index 03eac68..fd58666 100644
--- a/tests/test_cli.py
+++ b/tests/test_cli.py
@@ -105,28 +105,28 @@ class TestModuleNameOption(CliTestCase):
 
     def test_non_namespaced(self):
         cmd = self.get_cmd('foo')
-        self.assertEqual(cmd._repo_name, 'foo')
-        self.assertEqual(cmd.ns_repo_name, 'foo')
+        self.assertEqual(cmd.package._repo_name, 'foo')
+        self.assertEqual(cmd.package.ns_repo_name, 'foo')
 
     def test_just_module_name(self):
         cmd = self.get_cmd('foo', self.conf_file)
-        self.assertEqual(cmd._repo_name, 'foo')
-        self.assertEqual(cmd.ns_repo_name, 'rpms/foo')
+        self.assertEqual(cmd.package._repo_name, 'foo')
+        self.assertEqual(cmd.package.ns_repo_name, 'rpms/foo')
 
     def test_explicit_default(self):
         cmd = self.get_cmd('rpms/foo', self.conf_file)
-        self.assertEqual(cmd._repo_name, 'foo')
-        self.assertEqual(cmd.ns_repo_name, 'rpms/foo')
+        self.assertEqual(cmd.package._repo_name, 'foo')
+        self.assertEqual(cmd.package.ns_repo_name, 'rpms/foo')
 
     def test_with_namespace(self):
         cmd = self.get_cmd('container/foo', self.conf_file)
-        self.assertEqual(cmd._repo_name, 'foo')
-        self.assertEqual(cmd.ns_repo_name, 'container/foo')
+        self.assertEqual(cmd.package._repo_name, 'foo')
+        self.assertEqual(cmd.package.ns_repo_name, 'container/foo')
 
     def test_with_nested_namespace(self):
         cmd = self.get_cmd('user/project/foo', self.conf_file)
-        self.assertEqual(cmd._repo_name, 'foo')
-        self.assertEqual(cmd.ns_repo_name, 'user/project/foo')
+        self.assertEqual(cmd.package._repo_name, 'foo')
+        self.assertEqual(cmd.package.ns_repo_name, 'user/project/foo')
 
 
 class TestKojiConfigBackwardCompatibility(CliTestCase):
@@ -476,8 +476,12 @@ class TestSrpm(CliTestCase):
             cli = self.new_cli()
             cli.srpm()
 
-        expected_cmd = ['rpmbuild'] + cli.cmd.rpmdefines + \
-            ['--nodeps', '-bs', os.path.join(cli.cmd.path, cli.cmd.spec)]
+        expected_cmd = (
+            ['rpmbuild'] +
+            cli.cmd.package.rpmdefines +
+            ['--nodeps', '-bs', os.path.join(
+                cli.cmd.path, cli.cmd.package.spec)]
+        )
         _run_command.assert_called_once_with(expected_cmd, shell=True)
 
 
@@ -491,8 +495,8 @@ class TestCompile(CliTestCase):
             cli = self.new_cli()
             cli.compile()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + ['-bc', spec]
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + ['-bc', spec]
 
         _run_command.assert_called_once_with(rpmbuild, shell=True)
 
@@ -507,8 +511,8 @@ class TestCompile(CliTestCase):
             cli = self.new_cli()
             cli.compile()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + \
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + \
             ["--define '_builddir %s'" % builddir, '--target', 'i686', '--short-circuit',
              '--nocheck', '--quiet', '-bc', spec]
 
@@ -525,8 +529,8 @@ class TestPrep(CliTestCase):
             cli = self.new_cli()
             cli.prep()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + ['--nodeps', '-bp', spec]
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + ['--nodeps', '-bp', spec]
         _run_command.assert_called_once_with(rpmbuild, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -540,8 +544,8 @@ class TestPrep(CliTestCase):
             cli = self.new_cli()
             cli.prep()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + \
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + \
             ["--define '_builddir %s'" % builddir, '--target', 'i686', '--quiet', '--nodeps',
              '-bp', spec]
         _run_command.assert_called_once_with(rpmbuild, shell=True)
@@ -557,8 +561,8 @@ class TestInstall(CliTestCase):
             cli = self.new_cli()
             cli.install()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + ['-bi', spec]
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + ['-bi', spec]
 
         _run_command.assert_called_once_with(rpmbuild, shell=True)
 
@@ -573,8 +577,8 @@ class TestInstall(CliTestCase):
             cli = self.new_cli()
             cli.install()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + \
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + \
             ["--define '_builddir %s'" % builddir, '--target', 'i686', '--nocheck', '--quiet',
              '-bi', spec]
 
@@ -591,9 +595,10 @@ class TestLocal(CliTestCase):
             cli = self.new_cli()
             cli.local()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + ['-ba', spec]
-        tee = ['tee', '.build-%s-%s.log' % (cli.cmd.ver, cli.cmd.rel)]
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + ['-ba', spec]
+        tee = ['tee', '.build-%s-%s.log' % (cli.cmd.package.ver,
+                                            cli.cmd.package.rel)]
         cmd = '%s | %s; exit "${PIPESTATUS[0]} ${pipestatus[1]}"' % (
             ' '.join(rpmbuild), ' '.join(tee)
         )
@@ -610,11 +615,12 @@ class TestLocal(CliTestCase):
             cli = self.new_cli()
             cli.local()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + \
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + \
             ['--with', 'a', '--without', 'b', "--define '_builddir %s'" % builddir,
              '--target', 'i686', '--quiet', '-ba', spec]
-        tee = ['tee', '.build-%s-%s.log' % (cli.cmd.ver, cli.cmd.rel)]
+        tee = ['tee', '.build-%s-%s.log' % (cli.cmd.package.ver,
+                                            cli.cmd.package.rel)]
 
         cmd = '%s | %s; exit "${PIPESTATUS[0]} ${pipestatus[1]}"' % (
             ' '.join(rpmbuild), ' '.join(tee)
@@ -633,8 +639,8 @@ class TestVerifyFiles(CliTestCase):
             cli = self.new_cli()
             cli.verify_files()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + ['-bl', spec]
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + ['-bl', spec]
         _run_command.assert_called_once_with(rpmbuild, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -648,8 +654,8 @@ class TestVerifyFiles(CliTestCase):
             cli = self.new_cli()
             cli.verify_files()
 
-        spec = os.path.join(cli.cmd.path, cli.cmd.spec)
-        rpmbuild = ['rpmbuild'] + cli.cmd.rpmdefines + \
+        spec = os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        rpmbuild = ['rpmbuild'] + cli.cmd.package.rpmdefines + \
             ["--define '_builddir %s'" % builddir, '--quiet', '-bl', spec]
         _run_command.assert_called_once_with(rpmbuild, shell=True)
 
@@ -875,7 +881,7 @@ class TestLint(CliTestCase):
             cli = self.new_cli()
             cli.lint()
 
-        rpmlint = ['rpmlint', os.path.join(cli.cmd.path, cli.cmd.spec)]
+        rpmlint = ['rpmlint', os.path.join(cli.cmd.path, cli.cmd.package.spec)]
         _run_command.assert_called_once_with(rpmlint, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -889,7 +895,7 @@ class TestLint(CliTestCase):
             cli = self.new_cli()
             cli.lint()
 
-        rpmlint = ['rpmlint', '-i', os.path.join(cli.cmd.path, cli.cmd.spec)]
+        rpmlint = ['rpmlint', '-i', os.path.join(cli.cmd.path, cli.cmd.package.spec)]
         _run_command.assert_called_once_with(rpmlint, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -905,7 +911,10 @@ class TestLint(CliTestCase):
             cli = self.new_cli()
             cli.lint()
 
-        rpmlint = ['rpmlint', '-f', lint_config_path, os.path.join(cli.cmd.path, cli.cmd.spec)]
+        rpmlint = [
+            'rpmlint', '-f', lint_config_path,
+            os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        ]
         _run_command.assert_called_once_with(rpmlint, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -923,7 +932,10 @@ class TestLint(CliTestCase):
             cli = self.new_cli()
             cli.lint()
 
-        rpmlint = ['rpmlint', '-f', lint_config_path, os.path.join(cli.cmd.path, cli.cmd.spec)]
+        rpmlint = [
+            'rpmlint', '-f', lint_config_path,
+            os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        ]
         _run_command.assert_called_once_with(rpmlint, shell=True)
 
     @patch('pyrpkg.Commands._run_command')
@@ -942,8 +954,10 @@ class TestLint(CliTestCase):
             cli = self.new_cli()
             cli.lint()
 
-        rpmlint = ['rpmlint', '-f', custom_lint_config_path, os.path.join(cli.cmd.path,
-                   cli.cmd.spec)]
+        rpmlint = [
+            'rpmlint', '-f', custom_lint_config_path,
+            os.path.join(cli.cmd.path, cli.cmd.package.spec)
+        ]
         _run_command.assert_called_once_with(rpmlint, shell=True)
 
 
@@ -1359,7 +1373,8 @@ class TestMockbuild(CliTestCase):
 
     @patch('pyrpkg.Commands._config_dir_basic')
     @patch('pyrpkg.Commands._config_dir_other')
-    @patch('pyrpkg.Commands.mockconfig', new_callable=PropertyMock)
+    @patch('pyrpkg.pkginfo.PackageMetadata.mockconfig',
+           new_callable=PropertyMock)
     def test_use_mock_config_got_from_koji(
             self, mockconfig, config_dir_other, config_dir_basic):
         fd, tmpfile = tempfile.mkstemp()
@@ -1406,9 +1421,10 @@ class TestCoprBuild(CliTestCase):
 
     def setUp(self):
         super(TestCoprBuild, self).setUp()
-        self.nvr_patcher = patch('pyrpkg.Commands.nvr',
-                                 new_callable=PropertyMock,
-                                 return_value='rpkg-1.29-3.fc26')
+        self.nvr_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.nvr',
+            new_callable=PropertyMock,
+            return_value='rpkg-1.29-3.fc26')
         self.mock_nvr = self.nvr_patcher.start()
 
         self.srpm_patcher = patch('pyrpkg.cli.cliClient.srpm')
@@ -1472,23 +1488,27 @@ class TestMockConfig(CliTestCase):
                                     return_value='http://localhost/hub')
         self.mock_topurl = self.topurl_patcher.start()
 
-        self.disttag_patcher = patch('pyrpkg.Commands.disttag',
-                                     new_callable=PropertyMock,
-                                     return_value='fc26')
+        self.disttag_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.disttag',
+            new_callable=PropertyMock,
+            return_value='fc26')
         self.mock_disttag = self.disttag_patcher.start()
 
-        self.target_patcher = patch('pyrpkg.Commands.target',
-                                    new_callable=PropertyMock,
-                                    return_value='f26-candidate')
+        self.target_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.target',
+            new_callable=PropertyMock,
+            return_value='f26-candidate')
         self.mock_target = self.target_patcher.start()
 
-        self.localarch_patcher = patch('pyrpkg.Commands.localarch',
-                                       new_callable=PropertyMock,
-                                       return_value='x86_64')
+        self.localarch_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.localarch',
+            new_callable=PropertyMock,
+            return_value='x86_64')
         self.mock_localarch = self.localarch_patcher.start()
 
-        self.genMockConfig_patcher = patch('koji.genMockConfig',
-                                           return_value='x86_64 mock config')
+        self.genMockConfig_patcher = patch(
+            'koji.genMockConfig',
+            return_value='x86_64 mock config')
         self.mock_genMockConfig = self.genMockConfig_patcher.start()
 
         self.fake_build_target = {
@@ -1675,14 +1695,16 @@ class TestPatch(CliTestCase):
         self.Popen_patcher = patch('subprocess.Popen')
         self.mock_Popen = self.Popen_patcher.start()
 
-        self.repo_name_patcher = patch('pyrpkg.Commands.repo_name',
-                                       new_callable=PropertyMock,
-                                       return_value='docpkg')
+        self.repo_name_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.repo_name',
+            new_callable=PropertyMock,
+            return_value='docpkg')
         self.mock_repo_name = self.repo_name_patcher.start()
 
-        self.ver_patcher = patch('pyrpkg.Commands.ver',
-                                 new_callable=PropertyMock,
-                                 return_value='2.0')
+        self.ver_patcher = patch(
+            'pyrpkg.pkginfo.PackageMetadata.ver',
+            new_callable=PropertyMock,
+            return_value='2.0')
         self.mock_ver = self.ver_patcher.start()
 
     def tearDown(self):
@@ -1712,8 +1734,8 @@ class TestPatch(CliTestCase):
                 cli.patch()
                 m.return_value.write.assert_called_once_with('+ diff')
 
-        patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.module_name,
-                                                cli.cmd.ver)
+        patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.package.module_name,
+                                                cli.cmd.package.ver)
         self.mock_repo.return_value.repo.index.add.assert_called_once_with(
                 [patch_file])
 
@@ -1748,8 +1770,8 @@ class TestPatch(CliTestCase):
         with patch('sys.argv', new=cli_cmd):
             cli = self.new_cli()
 
-            patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.module_name,
-                                                    cli.cmd.ver)
+            patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.package.module_name,
+                                                    cli.cmd.package.ver)
             copied_patch_file = '{0}~'.format(patch_file)
 
             with patch.object(six.moves.builtins, 'open',
@@ -1788,8 +1810,8 @@ class TestPatch(CliTestCase):
         with patch('sys.argv', new=cli_cmd):
             cli = self.new_cli()
 
-            patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.module_name,
-                                                    cli.cmd.ver)
+            patch_file = '{0}-{1}-fix.patch'.format(cli.cmd.package.module_name,
+                                                    cli.cmd.package.ver)
             with patch('os.path.exists', return_value=False) as exists:
                 six.assertRaisesRegex(
                     self, rpkgError,
@@ -2341,7 +2363,7 @@ State:    failed
         mock_run.return_value = mock_proc
         with patch('sys.argv', new=cli_cmd):
             cli = self.new_cli()
-            file_path = os.path.join(self.cloned_repo_path, cli.cmd.module_name + '.yaml')
+            file_path = os.path.join(self.cloned_repo_path, cli.cmd.package.module_name + '.yaml')
             # we create an empty file for the purpose of this test so we don't raise an exception
             open(file_path, 'a').close()
             cli.module_build_local()
@@ -2367,7 +2389,7 @@ State:    failed
             cli = self.new_cli()
             cli.config.set("rpkg.mbs", "config_file", "/etc/module-build-service/custom.py")
             cli.config.set("rpkg.mbs", "config_section", "CustomSection")
-            file_path = os.path.join(self.cloned_repo_path, cli.cmd.module_name + '.yaml')
+            file_path = os.path.join(self.cloned_repo_path, cli.cmd.package.repo_name + '.yaml')
             # we create an empty file for the purpose of this test so we don't raise an exception
             open(file_path, 'a').close()
             cli.module_build_local()
@@ -2537,7 +2559,7 @@ State:    failed
             # we create an empty file for the purpose of this test so we don't
             # raise an exception
             modulemd_yml = os.path.join(self.cloned_repo_path,
-                                        cli.cmd.module_name + '.yaml')
+                                        cli.cmd.package.module_name + '.yaml')
             self.write_file(modulemd_yml)
 
             six.assertRaisesRegex(self, rpkgError, r'mbs-manager is missing.+',
@@ -2599,8 +2621,8 @@ class TestOptionNameAndNamespace(CliTestCase):
         ]
         with patch('sys.argv', new=cli):
             cli = self.new_cli()
-            self.assertEqual('somepkg', cli.cmd.module_name)
-            self.assertEqual('rpms', cli.cmd.ns)
+            self.assertEqual('somepkg', cli.cmd.package.repo_name)
+            self.assertEqual('rpms', cli.cmd.package.ns)
 
     def test_name_and_namespace_with_distgit_namespace_disabled(self):
         cli = [
@@ -2609,8 +2631,8 @@ class TestOptionNameAndNamespace(CliTestCase):
         ]
         with patch('sys.argv', new=cli):
             cli = self.new_cli()
-            self.assertEqual('somepkg', cli.cmd.module_name)
-            self.assertEqual('rpms', cli.cmd.ns)
+            self.assertEqual('somepkg', cli.cmd.package.repo_name)
+            self.assertEqual('rpms', cli.cmd.package.ns)
 
     def test_name_and_namespace_with_distgit_namespace_enabled(self):
         cli = [
@@ -2620,5 +2642,5 @@ class TestOptionNameAndNamespace(CliTestCase):
         with patch('sys.argv', new=cli):
             abs_filename = self.get_absolute_conf_filename('rpkg-ns.conf')
             cli = self.new_cli(abs_filename)
-            self.assertEqual('somepkg', cli.cmd.module_name)
-            self.assertEqual('modules', cli.cmd.ns)
+            self.assertEqual('somepkg', cli.cmd.package.repo_name)
+            self.assertEqual('modules', cli.cmd.package.ns)
